﻿#pragma once

#include "CoreMinimal.h"

enum ExpLightType
{
	None,
	Point,
	Directional,
	Spot
};

struct ExpLight
{
	ExpLightType type;

	FVector color;

	FVector pos;
	FVector forward;

	float range;     //for Point and Spot
	float angle;     //for Spot
};

enum ExpCamFlagBit
{
	FirstPerson		= 1 << 0,
	Translucent		= 1 << 1,
	SeparateOpaque	= 1 << 2,
};

struct MQuat	//equivalent to FQuat without the memory restrictions
{
	float X, Y, Z, W;

	operator FQuat() const { return FQuat(X, Y, Z, W); }
};

struct ExpFrame
{
	static const int MaxLights = 16;

	//Generated by MixCast Client
	unsigned long long frameIndex;
	unsigned long long syncTime;

	float camFramerate;
	unsigned int camWidth;
	unsigned int camHeight;

	FVector camPos;
	MQuat camRot;
	float camFoV;

	bool renderForeground;
	bool renderFull;

	unsigned int camFlags;
	bool HasCamFlag(ExpCamFlagBit flag) const
	{
		return (camFlags & (unsigned int)flag) > 0;
	}

	float occlusionApproxDepth;
	void* occlusionTex;

	//Generated by MixCast SDK
	void* layersTex;
	ExpLight lights[MaxLights];

	void* opaqueLayerTex;
};