/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#pragma once

#include "MixCastDefines.h"
#include "CoreMinimal.h"
#include "UObject/WeakObjectPtr.h"
#include "Components/SceneCaptureComponent2D.h"
#include "RendererInterface.h"
#include "SceneViewExtension.h"

#include "ExpPipelineTypes.h"
#include "Transmission/Unreal-Interop/SharedTextures/WatchedUnrealSharedTexture.h"
#include "MixCastShaders.h"

#include "OpaqueProcessingCaptureComponent.generated.h"

UCLASS()
class UOpaqueProcessingCaptureComponent : public USceneCaptureComponent2D
{
	GENERATED_BODY()
#if MIXCAST_SHADER_PASSES

public:
	DECLARE_EVENT_OneParam(UOpaqueProcessingCaptureComponent, FCaptureEvent, UOpaqueProcessingCaptureComponent*)

	UTextureRenderTarget2D* OpaqueTarget = NULL;
private:

	UStaticMeshComponent* dummyRenderer;	//needed for ensuring rendering occurs

	//PostOpaque (FinalColor mode)
	FPostOpaqueRenderDelegate reinsertOpaqueDel;
	FDelegateHandle reinsertOpaqueDelHandle;
	void ReinsertOpaque_RenderThread(FPostOpaqueRenderParameters& Parameters);

public:

	void Initialize();

	void BeginPlay() override;
	void EndPlay(EEndPlayReason::Type EndPlayReason) override;

	virtual void UpdateSceneCaptureContents(FSceneInterface* Scene) override;
#endif
};