#pragma once

#include "CoreMinimal.h"

class SharedTexIds
{
public:
	class Cameras
	{
	public:
		class RequestedExpFrames
		{
		public:
			static FString Get(const std::string cameraId) {
				static const TCHAR* IdFormat(TEXT("RequestedExpFrames({0})"));
				return FString::Format(IdFormat, { FStringFormatArg(FString(cameraId.c_str())) });
			}
		};

		class RenderedExpFrames
		{
		public:
			static FString Get(const std::string cameraId) {
				static const TCHAR* IdFormat(TEXT("RenderedExpFrames({0})"));
				return FString::Format(IdFormat, { FStringFormatArg(FString(cameraId.c_str())) });
			}
		};
	};

	class VideoInputs
	{
	public:
		class LatestColor
		{
		public:
			static FString Get(const std::string cameraId) {
				static const TCHAR* IdFormat(TEXT("{0}_latest_color"));
				return FString::Format(IdFormat, { FStringFormatArg(FString(cameraId.c_str())) });
			}
		};

		class LatestDepth
		{
		public:
			static FString Get(const std::string cameraId) {
				static const TCHAR* IdFormat(TEXT("{0}_latest_depth"));
				return FString::Format(IdFormat, { FStringFormatArg(FString(cameraId.c_str())) });
			}
		};
	};

	class Viewfinders
	{
	public:
		class Display
		{
		public:
			static FString Get(const std::string viewfinderId) {
				static const TCHAR* IdFormat(TEXT("{0}_view"));
				return FString::Format(IdFormat, { FStringFormatArg(FString(viewfinderId.c_str())) });
			}
		};
	};
};
