/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#pragma once

#include "CoreMinimal.h"
#include "Modules/ModuleInterface.h"
#include "Modules/ModuleManager.h"

class FMixCast_Oculus : public IModuleInterface
{
public:
	static inline FMixCast_Oculus& Get()
	{
		return FModuleManager::LoadModuleChecked< FMixCast_Oculus >( "MixCast_Oculus" );
	}

	static inline bool IsAvailable()
	{
		return FModuleManager::Get().IsModuleLoaded( "MixCast_Oculus" );
	}

	virtual void StartupModule() override;
	virtual void ShutdownModule() override;

	void HandleMixCastActiveChanged();
	void HandleTrackingSpaceChanged();
	void HandleMixCastAboutToRender();

private:
	FDelegateHandle activeStateDelegate;
	FDelegateHandle trackingSpaceChangedDelegate;
	FDelegateHandle beforeFrameDelegate;

	FVector cachedPlayRectPos;
	FQuat cachedPlayRectRot;
	FTransform trackingToPlayArea;

	bool CalculateHmdToWorldTransform(FTransform& trans);
	bool CalculateBaseToHmdTransform(FTransform& trans);
	bool CalculateTrackingToBaseTransform(FTransform& trans);
	bool CalculateTrackingToPlayAreaTransform(FTransform& trans);

	bool DetectBoundaryChanged();
};

