/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#pragma once

#include "MixCastDefines.h"

#include "CoreMinimal.h"
#include "Modules/ModuleInterface.h"
#include "Modules/ModuleManager.h"

class FMixCast_OpenXR : public IModuleInterface
{
public:
	static inline FMixCast_OpenXR& Get()
	{
		return FModuleManager::LoadModuleChecked< FMixCast_OpenXR >( "MixCast_OpenXR" );
	}

	static inline bool IsAvailable()
	{
		return FModuleManager::Get().IsModuleLoaded( "MixCast_OpenXR" );
	}

#if MIXCAST_OPENXR
	virtual void StartupModule() override;
	virtual void ShutdownModule() override;

	void HandleMixCastAboutToRender();

private:
	FDelegateHandle beforeFrameDelegate;

	bool CalculateHmdToWorldTransform(FTransform& trans);
	bool CalculateTrackingOriginToHmdTransform(FTransform& trans);
	bool CalculateTrackingOriginToStandingTransform(FTransform& trans);
#endif
};

