/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#pragma once 

#include "MixCastDefines.h"

#include "CoreMinimal.h"
#include "Shader.h"
#include "SceneView.h"
#include "Modules/ModuleInterface.h"
#include "Modules/ModuleManager.h"

class MIXCAST_SHADERS_API FMixCastShaders : public IModuleInterface
{
public:
	static inline FMixCastShaders& Get()
	{
		return FModuleManager::LoadModuleChecked< FMixCastShaders >("MixCast_Shaders");
	}

	static inline bool IsAvailable()
	{
		return FModuleManager::Get().IsModuleLoaded("MixCast_Shaders");
	}

	virtual void StartupModule() override;
	virtual void ShutdownModule() override;

	static void ReadAlpha(
		class IRendererModule& RendererModule,
		FRHICommandListImmediate& RHICmdList,
		class FSceneRenderTargets& SceneContext,
		class FSceneView& SceneView,
		class UTextureRenderTarget2D& AlphaTarget);

#if MIXCAST_SHADER_PASSES
	static void ReadOpaque(class IRendererModule& RendererModule, FPostOpaqueRenderParameters& Parameters, UTextureRenderTarget2D& OpaqueLayerTarget, bool ReadDepth);
	static void ReadDepth(class IRendererModule& RendererModule, FRHICommandList& RHICmdList, FSceneView& InView, UTextureRenderTarget2D& OpaqueLayerTarget);

	static void WriteOcclusion(FRHICommandListImmediate& RHICmdList, FSceneView& InView, bool basePass, FRHITexture* DepthTextureRHI, float DepthMultiplierValue);
	static void ClearPostOpaque(FRHICommandListImmediate& RHICmdList, FSceneView& InView);
	static void RewriteOpaque(FRHICommandListImmediate& RHICmdList, FSceneView& InView, FRHITexture* OpaqueTextureRHI);
#endif
};